Блог пользователя AC_AC

Автор AC_AC, история, 4 года назад, По-английски

I was solving Book Shop of CSES DP section.

  • I am getting TLE even after multiple attempts, Can you tell me how to optimize my TOP-DOWN approach.
  • I have tried replacing 2-d array with 2-d vector .
  • I have also tried swapping the dimensions of dp array ( some caching thing ).
my code
  • Проголосовать: нравится
  • 0
  • Проголосовать: не нравится

»
4 года назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

Everything is fine. Just set dp[index][total] = ans before returning.

  • »
    »
    4 года назад, # ^ |
      Проголосовать: нравится +1 Проголосовать: не нравится

    it is referenced with variable named ans,so i guess it should be fine, right??

»
4 года назад, # |
  Проголосовать: нравится +1 Проголосовать: не нравится

The time constraints in the CSES Problem set are very tight! In some problems using long long instead of int might also give TLE. So its always better to use Iterative method rather than Recursive(for CSES)

  • »
    »
    4 года назад, # ^ |
      Проголосовать: нравится 0 Проголосовать: не нравится

    yeah i read it somewhere, so should i assume that it is unsolvable using TOP-DOWN approach(on CSES)??

    • »
      »
      »
      4 года назад, # ^ |
        Проголосовать: нравится +1 Проголосовать: не нравится

      It might work for some Problems I'm not too sure about that but I do remember trying top_down approach for some Problems and got TLE too! Not that the solution was wrong, but the time constraints were just too tight for recursive solutions!! So yeah if you want AC in CSES then you have to solve iteratively(atleast for most of them or even all of them)!

  • »
    »
    3 года назад, # ^ |
      Проголосовать: нравится 0 Проголосовать: не нравится

    I kept on getting runtime error on my bottom up dp solution just because I used long long

  • »
    »
    3 года назад, # ^ |
      Проголосовать: нравится 0 Проголосовать: не нравится

    this worked for me...

    • »
      »
      »
      15 месяцев назад, # ^ |
        Проголосовать: нравится 0 Проголосовать: не нравится

      bro can you paste the AC code (recursive one)

      • »
        »
        »
        »
        15 месяцев назад, # ^ |
          Проголосовать: нравится 0 Проголосовать: не нравится

        Sorry I haven't written recursive . But iterative one :

        include<bits/stdc++.h>

        using namespace std;

        int mod = 1e9 +7; int main(){ int n,x; cin>>n>>x; pair<int,int> h[n];

        for(int i=0;i<n;i++){
            cin>>h[i].first;
        }
        for(int i=0;i<n;i++){
            cin>>h[i].second;
        }
        int dp[n+1][x+1];
        dp[0][0]=0;
        for(int i=0;i<=n;i++){
            dp[i][0] = 0;
        }
        for(int i=0;i<=x;i++){dp[0][i]=0;}
        for(int i=1;i<=n;i++){
            for(int j=1;j<=x;j++){
                dp[i][j] = dp[i-1][j];
                if(j>=h[i-1].first){
                    dp[i][j] = max(dp[i-1][j- h[i-1].first]+h[i-1].second,dp[i][j]);
                }
                dp[i][j] %= mod;
            }
        }

        cout<<dp[n][x]<<"\n"; }

        • »
          »
          »
          »
          »
          15 месяцев назад, # ^ |
          Rev. 2   Проголосовать: нравится 0 Проголосовать: не нравится

          I am using iterative way but still getting tle what could be the reason here is the code

          include

          include

          using namespace std;

          int main() { ios::sync_with_stdio(false); cin.tie(0);

          int n, x;
          cin >> n >> x;
          int dp[x + 1][n + 1];
          int prices[n + 1];
          int pages[n + 1];
          memset(dp, 0, sizeof(dp));
          
          for (int i = 1; i <= n; i++)
          {
              cin >> prices[i];
          }
          for (int j = 1; j <= n; j++)
          {
              cin >> pages[j];
          }
          
          for (int i = 1; i <= x; i++)
          {
              for (int j = 1; j <= n; j++)
              {
                  dp[i][j] = max(dp[i][j - 1], (i - prices[j]) >= 0 ? (dp[i - prices[j]][j - 1] + pages[j]) : 0);
              }
          }
          
          cout << dp[x][n] << "\n";
          return 0;

          }

          • »
            »
            »
            »
            »
            »
            14 месяцев назад, # ^ |
              Проголосовать: нравится +3 Проголосовать: не нравится

            Your code seems perfect to me. Did you find the error?

            • »
              »
              »
              »
              »
              »
              »
              14 месяцев назад, # ^ |
                Проголосовать: нравится 0 Проголосовать: не нравится

              Yes.

            • »
              »
              »
              »
              »
              »
              »
              13 месяцев назад, # ^ |
                Проголосовать: нравится 0 Проголосовать: не нравится

              Nope

              • »
                »
                »
                »
                »
                »
                »
                »
                10 месяцев назад, # ^ |
                  Проголосовать: нравится 0 Проголосовать: не нравится

                In my case I was using long long everywhere which was giving me Runtime Error however Just after replacing it with Int it got Accepted.

»
2 месяца назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

Surprisingly, my solution with a complexity of O(1e8) was accepted, and it ran in only 0.1 seconds.

»
4 дня назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

I'm surprised that this is for 3 years ago but the latest comments are from 2 weeks ago.

I just got accepted on the task and I had the same problem. I mean technically it should've been an MLE. I dont know if anyone has said this before or not, but here instead of defining a DP[100000][100] I just defined a DP[100000][2] since you only need dp[j][i-1] to update your DP, So you can just store the previous row of your DP table and use parity to go over the loop and store your values.

here's my code:

#include <bits/stdc++.h>
using namespace std;
 
const int mxx = 1e5 + 1;
const int mxn = 1e3 + 1;
int dp[mxx][2];
int s[mxn], h[mxn];
 
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    int n, x;
    cin >> n >> x;
    for (int i = 0; i < n; i++) cin >> h[i];
    for (int i = 0; i < n; i++) cin >> s[i];
    for (int i = 0; i < x + 1; i++) {
        if (h[0] <= i) dp[i][0] = s[0];
        else dp[i][0] = 0;
    }
 
    for (int i = 1; i < n; i++) {
        for (int j = 0; j <= x; j++) {
            if (h[i] > j) dp[j][i%2] = dp[j][1 - (i%2)];
            else dp[j][i%2] = max(dp[j][1 - (i%2)], dp[j - h[i]][1 - (i%2)] + s[i]);
        }
    }
 
    cout << dp[x][(n-1) % 2];
}